org.optaplanner.core.impl.domain.valuerange.descriptor

## Class FromSolutionPropertyValueRangeDescriptor<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.domain.valuerange.descriptor.AbstractValueRangeDescriptor<Solution_>
  - - org.optaplanner.core.impl.domain.valuerange.descriptor.AbstractFromPropertyValueRangeDescriptor<Solution_>
    - - org.optaplanner.core.impl.domain.valuerange.descriptor.FromSolutionPropertyValueRangeDescriptor<Solution_>

- Type Parameters:
    `Solution_` - the solution type, the class with the `PlanningSolution` annotation
  All Implemented Interfaces:
    EntityIndependentValueRangeDescriptor<Solution_>, ValueRangeDescriptor<Solution_>

      public class FromSolutionPropertyValueRangeDescriptor<Solution_>
      extends AbstractFromPropertyValueRangeDescriptor<Solution_>
      implements EntityIndependentValueRangeDescriptor<Solution_>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.domain.valuerange.descriptor.AbstractFromPropertyValueRangeDescriptor

      `arrayWrapping, collectionWrapping, countable, memberAccessor`

    - ### Fields inherited from class org.optaplanner.core.impl.domain.valuerange.descriptor.AbstractValueRangeDescriptor

      `addNullInValueRange, variableDescriptor`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FromSolutionPropertyValueRangeDescriptor(GenuineVariableDescriptor<Solution_> variableDescriptor, boolean addNullInValueRange, MemberAccessor memberAccessor)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ValueRange<?>` | `extractValueRange(Solution_ solution)` As specified by `ValueRangeDescriptor.extractValueRange(Solution_, java.lang.Object)`.
    `ValueRange<?>` | `extractValueRange(Solution_ solution, Object entity)`
    `boolean` | `isEntityIndependent()` If this method return true, this instance is safe to cast to `EntityIndependentValueRangeDescriptor`, otherwise it requires an entity to determine the `ValueRange`.

    - ### Methods inherited from class org.optaplanner.core.impl.domain.valuerange.descriptor.AbstractFromPropertyValueRangeDescriptor

      `isCountable, readValueRange`

    - ### Methods inherited from class org.optaplanner.core.impl.domain.valuerange.descriptor.AbstractValueRangeDescriptor

      `doNullInValueRangeWrapping, getVariableDescriptor, mightContainEntity, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.domain.valuerange.descriptor.ValueRangeDescriptor

      `getVariableDescriptor, isCountable, mightContainEntity`

- - ### Constructor Detail

    - #### FromSolutionPropertyValueRangeDescriptor

          public FromSolutionPropertyValueRangeDescriptor(GenuineVariableDescriptor<Solution_> variableDescriptor,
                                                          boolean addNullInValueRange,
                                                          MemberAccessor memberAccessor)

  - ### Method Detail

    - #### isEntityIndependent

          public boolean isEntityIndependent()

      Description copied from interface: `ValueRangeDescriptor`
      If this method return true, this instance is safe to cast to `EntityIndependentValueRangeDescriptor`, otherwise it requires an entity to determine the `ValueRange`.
      Specified by:
        `isEntityIndependent` in interface `ValueRangeDescriptor<Solution_>`
      Returns:
        true if the `ValueRange` is the same for all entities of the same solution

    - #### extractValueRange

          public ValueRange<?> extractValueRange(Solution_ solution,
                                                 Object entity)

      Specified by:
        `extractValueRange` in interface `ValueRangeDescriptor<Solution_>`
      Parameters:
        `solution` - never null
        `entity` - never null. To avoid this parameter, use `EntityIndependentValueRangeDescriptor.extractValueRange(Solution_)` instead.
      Returns:
        never null

    - #### extractValueRange

          public ValueRange<?> extractValueRange(Solution_ solution)

      Description copied from interface: `EntityIndependentValueRangeDescriptor`
      As specified by `ValueRangeDescriptor.extractValueRange(Solution_, java.lang.Object)`.
      Specified by:
        `extractValueRange` in interface `EntityIndependentValueRangeDescriptor<Solution_>`
      Parameters:
        `solution` - never null
      Returns:
        never null
      See Also:
        `ValueRangeDescriptor.extractValueRange(Solution_, java.lang.Object)`

Copyright © 2006–2019 JBoss by Red Hat. All rights reserved.